<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_17</title>
</head>
<body>
    <h1>Capitulo 17</h1>
    <a>Ejercicio 15</a>

    <script>

        const comparar = (s1, s2) => {
            return s2.length - s1.length;
        }
 
        const formarPalbra = (s,isoriginalword,mp) => {
 
            if (mp.has(s) && mp.get(s) == 0) {
                return false;
            }
 
            if (mp.has(s) && mp.get(s) == 1 && isoriginalword == 0) {
                return true;
            }
 
            for (let i = 1; i < s.length; i++) {
 
                let left = s.substring(0, i);
                let right = s.substring(i);

                if (mp.has(left) == true && mp.get(left) == 1 && formarPalbra(right, 0, mp)) {
                    return true;
                }
            }
 
            mp.set(s,0);
            return false;
        }
 
        const imprimirPalabra = (listaDePalab) => {
 
            let mp = new Map();

            for (let s of listaDePalab) {
                mp.set(s,1);
            }
 
            listaDePalab.sort(comparar);
 
            for (let s of listaDePalab) {
 
                if (formarPalbra(s, 1, mp)) {
                    return s;
                }
            }
 
            return "-1";
        }
 
        let listaDePalab = ["cat", "banana", "dog", "nana", "walk", "walker", "dogwalker"];
        console.log(`La lista formada por otras palabras de la lista es: ${imprimirPalabra(listaDePalab)}`);

    </script>
    
</body>
</html>